#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) 2010 Gauvain Pocentek <gauvain.pocentek@objectif-libre.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

class VEPError (Exception):
    def __init__ (self, msg):
        self.msg = msg

    def __str__ (self):
        return self.msg

class MovieUnknownError (VEPError):
    """
    Raised when a requested movie id can't be found
    """

class PeopleUnknownError (VEPError):
    """
    Raised when a requested person id can't be found
    """

class MountFailedError (VEPError):
    """
    Raised when a partition could not be mounted
    """

class DbLoadError (VEPError):
    """
    Raised when the connection to the database engine could not be made
    """
