#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) 2010 Gauvain Pocentek <gauvain.pocentek@objectif-libre.com>
# Copyright (C) 2010 Guillaume Espanel <guillaume.espanel@objectif-libre.com>
# Copyright (C) 2010 Christophe Sauthier <christophe.sauthier@objectif-libre.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from VideoEnPoche.dal import Movie, Category, Resolution, License,  Session
session = Session()

def dfl(list,key="id"):
    o = {}
    for i in list:
        o[i.__getattribute__(key)] = i
    return o

def get_resolutions ():
    return session.query(Resolution).all()

def get_licenses ():
    return session.query(License).all()

def get_rightsholders ():
    return []

def get_types ():
    return session.query(Category).all()


def _people_list_for_movie (movie_id):
    return None

def _movie_list_from_db_fetchall (db):
    return dfl(session.query(Movie).all())

def get_number (method, search_str):
    init_q = session.query(Movie).filter(Movie.state=="visible")
    if method == 'search':
        init_q = session.query(Movie).filter(Movie.state=="visible")
        where = ''
        search_str = search_str.replace ('%20', ' ')
        for word in search_str.split ():
            init_q = init_q.filter(Movie.title.like("%%%s%%"%word))
    return init_q.count()

def get_movies_by_date (offset=0, limit=14):
    limit = offset+limit
    return dfl(session.query(Movie).\
            filter(Movie.state=="visible").\
            order_by(Movie.id.desc())[offset:limit])


def get_movies_from_search (search, offset=0, limit=14):
    limit = limit+offset
    init_src = session.query(Movie).filter(Movie.state=="visible")
    search = search.replace ('%20', ' ')
    for word in search.split ():
        init_src = init_src.filter(Movie.title.like("%%%s%%" % word))
    init_src = init_src.order_by(Movie.id.desc())
    return dfl(init_src[offset:limit])

def get_movies_by_type (type, offset=0, limit=14):
    limit=limit+offset
    return dfl(session.query(Movie).\
            filter(Movie.state=="visible").\
            filter(Movie.type==type).\
            order_by(Movie.id.desc())[offset:limit])

def get_movies_by_state (state):
    return dfl(session.query(Movie).filter(Movie.state==state).all())

def ack_announcement(movie_id):
    movie = session.query(Movie).get(movie_id)
    movie.state = "visible"
    session.add(movie)
    session.commit()
