var types = $H();
var resolutions = $H();
var licenses = $H();
var movies = $H();
var announced_movies = $H();
var downloading_movies = $H();
var queued_movies = $H();
var cart = $H(); /* movie_id => movie_data */
var current = $H();
var devices;
var offset = 0;
var movies_nb = 0;
var search_type = 'default';
var search_str = '';
var devices_handled = true;

function init () {
    // Movies Init
    moviesInit ();

    // Devices Init
    devicesInit ();

    // Tabs Init
    tabsInit();

    // Cookies Init
    cookiesInit ();

    //Pending Init
    pendingInit ();

    // Announce Init
    announcesInit ();

    // Debug Init
    debugInit ();

    // Init the packages list used for modification of movies
    init_packages_list();
}

function moviesInit() {
    new Ajax.Request ('/webservices/get_types',
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                data = transport.responseText.evalJSON();
                data.each (function (item) {
                    types.set(item.id, item.name);
                })
            }
        });

    new Ajax.Request ('/webservices/get_resolutions',
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                data = transport.responseText.evalJSON();
                data.each (function (item) {
                    resolutions.set(item.id, item.name);
                })
            }
        });

    new Ajax.Request ('/webservices/get_licenses',
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                data = transport.responseText.evalJSON();
                data.each (function (item) {
                    licenses.set(item.id, new Array (item.html, item.pdf, item.name));
                })
            }
        });

    //gen_types_select ();
    get_movies ();
}

function devicesInit() {
    new PeriodicalExecuter (manage_devices_and_announces, 1);
}

function tabsInit() {
    new Control.Tabs('barreonglets');
    new Control.Tabs('barreongletsadmin');
}

function pendingInit() {
  // Initialisation of the Downloading and Queued movies list
  get_pending_movies ();
}

function announcesInit() {
  // Initialisation of the Downloading and Queued movies list
  get_announces ();
}

function debugInit() {
    //Initialisation of the Debug block
    new Ajax.Request ('/webservices/check_debug',
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                if (transport.responseText == 'True') {
                    set_debug_block();
                }
            }
        });
}

function load_current_settings () {
    new Ajax.Request ('/webservices/get_settings',
        {
            method: 'get',
            onSuccess: function (transport) {
                data = $H(transport.responseText.evalJSON());
                data.each (function (item) {
                    el_id = 'config_'+item.key;
                    if (item.key == 'debug') {                      
                        if (item.value) {
                            $(el_id).checked=true;
                        }
                        else {
                            $(el_id).checked=false;
                        }
                    }
                    else {
                        $(el_id).setAttribute ('value', item.value);
                    }
                })
            }
        });
}

function gen_types_select () {
    el = $('type_select');
    opt = new Element('option', { 'value': 0, 'selected': 'selected' }).update ('All');
    el.appendChild (opt);
    types.each (function (pair) {
        opt = new Element ('option', {'value': pair.key}).update (pair.value);
        el.appendChild (opt);
    });
}

function enable_vep_mount (b) {
    var v = b ? "1" : "0";
    new Ajax.Request ('/webservices/set_devices_handled/'+v,
    {
        method: 'get',
        asynchronous: false,
    });
    devices_handled = !b;
    toggle_vep_device_handling ();
}

function toggle_vep_device_handling () {
    d = $('enable_mount');
    if (devices_handled) {
        d.setAttribute ('onclick', 'enable_vep_mount (false); return false;');
        d.setAttribute ('value', '___USB by VeP___');
    } else {
        d.setAttribute ('onclick', 'enable_vep_mount (true); return false;');
        d.setAttribute ('value', '___USB by Ubuntu___');
    }
}

function get_movies_number () {
    new Ajax.Request ('/webservices/get_movies_number/'+search_type+'/'+search_str,
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                movies_nb = transport.responseText;
            }
        });
}

function get_movies_list (json) {
    movies = $H();
    data = json.evalJSON();

    iter=[]
    for (key in data) {
        iter.push(data[key])
    }
    
    data_ordered = iter.sortBy(function(s) {return s.id;});
    data = data_ordered.reverse(false);
    data.each(function(s) { movies.set(s.id, s); });
    movies_array = data;
}

function get_announced_movies_list (json) {
    announced_movies = $H();
    data = json.evalJSON();
    for (key in data) {
        announced_movies.set (key, data[key]);
    }
}

function get_downloading_movies_list (json) {
    downloading_movies = $H();
    data = json.evalJSON();
    for (key in data) {
        downloading_movies.set (key, data[key]);
    }
}

function get_queued_movies_list (json) {
    queued_movies = $H();
    data = json.evalJSON();
    for (key in data) {
        queued_movies.set (key, data[key]);
    }
}

function get_movies_by_type () {
    new Ajax.Request ('/webservices/get_movies_by_type/'+$('type_select').value,
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                set_movies_list (transport.responseText);
            }
        });
}

function get_search (newoffset) {
    search_type = 'search';
    search_str = $('search_box').value;
    if (search_str == '')
        return;
    get_movies (newoffset);
}

function get_all_movies () {
    search_type = 'default';
    offset = 0;
    $('search_box').value = '';
    get_movies (0);
}

function get_movies (newoffset) {
    if (newoffset == undefined) newoffset = offset;
    if (search_type == 'default')
        url = '/webservices/get_movies/default/'+newoffset;
    else if (search_type == 'search')
        url = '/webservices/get_movies/search/'+search_str+'/'+newoffset;
    else
        url = '/webservices/get_movies/default/'+newoffset;

    new Ajax.Request (url,
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                offset = newoffset;
                set_movies_list (transport.responseText);
            }
        });
}

function get_announces () {
    new Ajax.Request ('/webservices/get_movies/state/announced/',
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                set_announced_list (transport.responseText);
            }
        });
}

function get_pending_movies () {
    new Ajax.Request ('/webservices/get_movies/state/downloading/',
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                set_downloading_list (transport.responseText);
            }
        });
     new Ajax.Request ('/webservices/get_movies/state/queued/',
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                set_queued_list (transport.responseText);
            }
        });
}

function toggle_add_remove (movie_id) {
    var a = $$('#cart_btn_'+movie_id);
    a.each (function (d) {
        if (cart.get (movie_id)) {
            d.setAttribute ('onclick', 'remove_from_cart ("'+movie_id+'"); toggle_add_remove ("'+movie_id+'");');
            d.setAttribute ('value', '___Remove___');
        } else {
            d.setAttribute ('onclick', 'add_to_cart ("'+movie_id+'"); toggle_add_remove ("'+movie_id+'");');
            d.setAttribute ('value', '___Add___');
        }
    }
    )
}

function set_debug_block () {
    $('debug_li').show();
}

function set_movies_list (json) {
    $('movie_list_div').update ('');
    $('movie_detail_div').update ('');
    get_movies_number ();
    get_movies_list (json);
    

    movies_array.each (function (d) {
        movie_id = d.id;
        div = new Element ('div', { 'class': 'movie'});
        a = new Element ('a', {'class': 'movie_infos', 'href': '#', 'onclick': 'show_movie ('+movie_id+');'})
        image = new Element ('img', {'class': 'movie_img', 'src': '/images/'+movies.get(movie_id).poster_filename});
        p = new Element ('p', {'class': 'movie_title'}).update(d.title);
        
        p_cart = new Element ('p', {'class': 'movie_add_button'});
        if (cart.get (movie_id)) {
            input = new Element ('input', { 'type': 'submit',
                                            'href': '#',
                                            'class': 'cart',
                                            'id': 'cart_btn_'+movie_id,
                                            'onclick': 'remove_from_cart ("'+movie_id+'"); toggle_add_remove ("'+movie_id+'");',
                                            'value': '___Remove___',
                                            'movie_id': movie_id
                                       });
        } else {
            input = new Element ('input', { 'type': 'submit',
                                            'href': '#',
                                            'class': 'cart',
                                            'id': 'cart_btn_'+movie_id,
                                            'onclick': 'add_to_cart ("'+movie_id+'"); toggle_add_remove ("'+movie_id+'");',
                                            'value': '___Add___',
                                            'movie_id': movie_id});
        }


        a.appendChild(image);
        a.appendChild(p);

        p_cart.appendChild(input);
        div.appendChild(a);
        div.appendChild(p_cart);
        $('movie_list_div').appendChild (div);
    });

    // All pages contains 14 movies
    if  (((offset+14) < movies_nb) || (offset != 0))  {
        div = new Element ('div', { 'class': 'nav_movie_arrow'});         

        if (offset != 0) {
            // All pages contains 14 movies
            a = new Element ('a', {'href': '#', 'onclick': 'get_movies ('+(offset-14)+');'});
            image = new Element ('img', {'class': 'right_arrow', 'src': '/images/icones/left-arrow.png'});
            a.appendChild(image);
            div.appendChild(a);
        }

        if ((offset+14) < movies_nb) {
            a = new Element ('a', {'href': '#', 'onclick': 'get_movies ('+(offset+14)+');'});
            image = new Element ('img', {'class': 'right_arrow', 'src': '/images/icones/right-arrow.png'});
            a.appendChild(image);
            div.appendChild(a);
        }

            
      $('movie_list_div').appendChild (div);
    }

}


function set_announced_list (json) {
    get_announced_movies_list (json);
        
    ul = new Element ('ul', { 'id': 'announces_list' });
    announced_movies.each (function (d) {
        movie_id = d.key;
        li = new Element ('li');
        txt ="<form ><a onclick=\"ack_announcement('movies','"+movie_id+"');get_movies ()\">+ "+d.value['title']+"</a></form>";
        span = new Element ('span').update (txt);
        li.appendChild (span);
        ul.appendChild (li);
    });
    $('announces_list_div').update (ul);
}

function ack_announcement(type,id) {
    new Ajax.Request ('/webservices/ack_announce/'+type+'/'+id,
        {
            method: 'get',
            asynchronous: false
        });
    
    // Let's fire get_announce to get the refresh
    get_announces ();
}

function set_downloading_list (json) {
    $('movie_downloading_list_div').update ('');
    get_downloading_movies_list (json);
    
   

    downloading_movies.each (function (d) {
        movie_id = d.key;
        div = new Element ('div', { 'class': 'downloading_movie'});
        p = new Element ('p', {'class': 'downloading_movie_title'}).update(d.value['title']+" "+d.value['download_completion']+" %");
        
        div.appendChild(p);
        $('movie_downloading_list_div').appendChild (div);
    });
}


function set_queued_list (json) {
    $('movie_queued_list_div').update ('');
    get_queued_movies_list (json);
    
   

    queued_movies.each (function (d) {
        movie_id = d.key;
        div = new Element ('div', { 'class': 'queued_movie'});
        p = new Element ('p', {'class': 'queued_movie_title'}).update(d.value['title']);
        
        div.appendChild(p);
        $('movie_queued_list_div').appendChild (div);
    });
}

function remove_from_cart (movie_id) {
    cart.unset (movie_id);
    update_cart_div ();
}

function add_to_cart (movie_id) {
    cart.set (movie_id, movies.get (movie_id));
    update_cart_div ();
}

function empty_cart () {
    cart = $H ();
    update_cart_div ();
    $('movie_detail_div').update (''); /* avoid a broken link */
}

function update_cart_div () {
    if (cart.size () == 0) {
        $('cart_status_div').update ('___Nothing in the cart___');
        return;
    }

    var txt = "<a href='#' onclick='empty_cart (); get_movies (\""+offset+
              "\")'>___Empty the cart___</a><br />\n";
    txt += "<br /><ul>\n";
    cart.each (function (d) {
        k = d.key;
        v = d.value;
        txt += '<li>'+v.title+" <a href='#' onclick='remove_from_cart (\""+k+"\"); "+
                                "toggle_add_remove (\""+k+"\");'>(___Remove___)</a></li>\n";
    });
    txt += "</ul><br />\n";

    /* offer a choice of devices on which to perform the copy */
    txt += "<ul>\n";
    devices.each (function (d) {
        v = d.value.evalJSON();
        /* if we are already copying files on a device, exclude it from the list */
        if (current.get (d.key))
            return;
        /* also exclude devices that are not writable */
        if (v['usable'] != 1)
            return;
        txt += "<li><a href='#' onclick='copy_cart (\""+d.key+"\");'>___Copy on___ "+v['label']+"</a></li>\n";
    });
    txt += "</ul>\n";

    $('cart_status_div').update (txt);
}

function copy_cart (device) {
    /* check if we have enough disk space */
    required_size = 5000000 // 5M for the invoice, should be enough!
    cart.each (function (d) {
        required_size += d.value.size * 1048576; /* Mbytes => bytes */
    });
    free_space = devices.get (device).evalJSON()['freespace'];
    if (required_size > free_space) {
        alert ('___Not enough space on the disk!___');
        return;
    }

    /* store the new transaction and perform the copy */
    var l = ''
    cart.each (function (d) {
        l += '/'+d.key;
    });
    current.set (device, 1); /* we only use the hash keys for now, so dummy value */
    empty_cart ();
    get_movies (); /* refresh the display */
    new Ajax.Request ('/webservices/init_transaction/'+device+l,
        {
            method: 'get'
        });
}

function show_movie (movie_id) {
    var txt = types.get(movies.get(movie_id).category_id)+"<br />\n";
    txt += "<img src=\"/images/"+movies.get(movie_id).poster_filename+"\"><br />\n";
    txt += movies.get(movie_id).desc+"<br />\n";
    txt += "___Resolution___: "+resolutions.get(movies.get(movie_id).resolution_id)+"<br />\n";
    txt += "<br /><br />";
    Modalbox.show (txt, {title: movies.get(movie_id).title, width: 800});
}

	

    

function remove_device (device) {
    new Ajax.Request ('/webservices/remove_device/'+device,
        {
            method: 'get',
            onSuccess: function (transport) {
                if (transport.responseText == 'false') {
                    alert ("___Unable to properly remove the device___");
                }
            }
        });
}

function cancel_transaction (device) {
    new Ajax.Request ('/webservices/cancel_transaction/'+device,
        {
            method: 'get'
        });
}

function show_devices_status () {
    ul = new Element ('ul', { 'id': 'devices_list' });
    devices.each (function (d) {
        txt = '';
        li = new Element ('li');
        ul.appendChild (li);
        props = d.value.evalJSON(); // FIXME (should be already interpreted?)
        s = props['global_status'];
        if (current.get (d.key)) {
            txt += props['label']

            if ((typeof (s) == typeof (1)) || (s == "syncing") || (s == "validating")) {
                txt += " <a href='#' onclick='cancel_transaction(\""+d.key+"\");'>";
                txt += "___CANCEL___</a>";
                txt += " &ndash; ";
                txt += "___Progress:___ "+s;
                if (typeof (s) == typeof (1))
                    txt += "%";
            }
            else if (s == "cancel") {
                txt += " (___Stopping the transaction___)";
            }
            else if (s == "OK") {
                txt += "___Done___";
                current.unset (d.key);
                remove_device (d.key);
            }
            else {
                txt += "___Progress:___ "+s;
            }
        }
        else {
            var extra = '';
            if (props['usable'] != 1)
                extra = "<img src='/images/edit-delete.png' border='0' />";
            txt += extra+props['label']+" <a href='#' onclick='remove_device(\""+d.key+"\");'>";
            txt += "___REMOVE___</a>";
        }

        span = new Element ('span').update (txt);
        li.appendChild (span);
    })
    $('devices_status_div').update (ul);

    update_cart_div ();
}

function do_cancel (d) {
    current.unset (d);
    new Ajax.Request ('/webservices/ack_cancel/'+d,
        { method: 'get'}
    );
}

function check_copy_done () {
    current.each (function (d) {
        device = devices.get (d.key);
        props = device.evalJSON ();

        s = props['global_status'];
        if (typeof (s) != 'string')
            return;
        if (s == 'cancel') {
            do_cancel (d.key);
            return;
        }

        new Ajax.Request ('/webservices/conclude_transaction/'+d.key,
            {
                method: 'get',
                asynchronous: false
            });
    })
}

function manage_devices_and_announces (pe) {
    // activate devices handler
    new Ajax.Request ('/webservices/get_devices_handled',
        {
            method: 'get',
            onSuccess: function (transport) {
                devices_handled = false;
                if (transport.responseText == 'true')
                    devices_handled = true;
                toggle_vep_device_handling ();
            }
        });

    new Ajax.Request ('/webservices/get_all_devices',
        {
            method: 'get',
            onSuccess: function (transport) {
                devices = $H(transport.responseText.evalJSON());
                show_devices_status ();
                check_copy_done ();
            }
        });

    // Let's hide/display the devices list on demande when there is nothing to
    // display
    if ($('devices_list') && $('devices_list').childNodes.length != 0) {
      $('devices').show();
    }
    else {
      $('devices').hide();
    }
    
    // Let's hide/display the annouces list on demande when there is nothing to
    // display
    if ($('announces_list') && $('announces_list').childNodes.length != 0) {
      $('announces').show();
    }
    else {
      $('announces').hide();
    }
}


function load_debug_values () {
    new Ajax.Request ('/webservices/get_debug_values',
        {
            method: 'get',
            onSuccess: function (transport) {
                data = $H(transport.responseText.evalJSON());
                data.each (function (item) {
                    el_id = 'debug_'+item.key+'_value';
                    $(el_id).setAttribute ('value', item.value);
                })
            }
        });
}

function init_packages_list() {
    $('package_select').update('<option>Packages : </option>');
    new Ajax.Request ('/webservices/get_pkg_list',
        {
            method: 'get',
            asynchronous: false,
            onSuccess: function (transport) {
                data = transport.responseText.evalJSON();
                for(title in data){
                        var option = new Element('option', {'value': data[title]}).update(title);
                        $('package_select').appendChild(option);
                }
            }
        });
}




function update_package_selection() {
    new Ajax.Request('/webservices/get_pkg/'+$("package_select").value,
        {
	    method: 'get',
	    onSuccess: function(transport) {
                data = transport.responseText.evalJSON();
		$("editmovie_title").value = data['title']; 
		$("editmovie_id").value = data['dist_network_id']; 
		$("editmovie_desc").value = data['desc'];
		$("editmovie_file").value = data['filename'];
		$("editmovie_poster").value = data['poster_filename'];
		$("editmovie_length").value = data['length'];
		$("editmovie_price").value = data['price'];
		$("editmovie_vat").value = data['vat'];
		$("editmovie_right_holders_share").value = data['right_holders_share'];
		$("editmovie_bonus").value = data['bonus_filename'];
		$("editmovie_bonus_desc").value = data['bonus_desc'];
	   }
	});
}
