#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Copyright (C) 2010 Gauvain Pocentek <gauvain.pocentek@objectif-libre.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import os
import re
import glob
import subprocess

header = """# SOME DESCRIPTIVE TITLE.
# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
# This file is distributed under the same license as the PACKAGE package.
# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
#
#, fuzzy
msgid ""
msgstr ""
"Project-Id-Version: PACKAGE VERSION\\n"
"Report-Msgid-Bugs-To: \\n"
"POT-Creation-Date: 2010-09-10 15:08+0200\\n"
"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\\n"
"Last-Translator: FULL NAME <EMAIL@ADDRESS>\\n"
"Language-Team: LANGUAGE <LL@li.org>\\n"
"Language: \\n"
"MIME-Version: 1.0\\n"
"Content-Type: text/plain; charset=CHARSET\\n"
"Content-Transfer-Encoding: 8bit\\n"
"""

TARGET = "po/videoenpoche.pot"

regex = re.compile (r".*___((?:[^(___)]|\(|\))+)___.*")

msgids = {}
ordered_keys = []
for f in open ("po/POTFILES", "r").readlines():
    if f[-1] == "\n":
        f = f[:-1]
    linenb = 0
    for line in open (f, "r").readlines():
        linenb += 1
        m = regex.match (line)
        if not m:
            continue
        for g in m.groups():
            if not msgids.has_key (g):
                msgids[g] = ["%s:%d"%(f, linenb)]
                ordered_keys.append (g)
            else:
                msgids[g].append ("%s:%d"%(f, linenb))

t = open (TARGET, "w")
t.write (header)
for k in ordered_keys:
    for where in msgids[k]:
        t.write ('#: %s\n'%where)
    t.write ('msgid "%s"\n'%k)
    t.write ('msgstr ""\n')
    t.write ('\n')
t.close ()

for po in glob.glob ('po/*.po'):
    ret = subprocess.call(['msgmerge', po, TARGET, '-o', '%s.tmp'%po])
    if ret != 0:
        print "Unable to merge %s"%po
        os.unlink ('%s.tmp'%po)
    else:
        os.rename ('%s.tmp'%po, po)
